'+--------------------------[ FonWatch Ver 1.00 ]----------------------------+
'|  Written By Gary Meeker 12/21/91                        Updated   /  /    |
'|  SYSOP: SHARP Technical Support Line BBS               Lawrenceville, GA  |
'|         (404) 962-1788                 300/1200/2400/9600 Baud. 24 Hours  |
'+---------------------------------------------------------------------------+
'V1.0 12/21/91 - Initial release

DEFINT A-Z

'   QuickPack Declarations
DECLARE SUB SetLevel (ErrLevel%)
DECLARE SUB FCopy (Source$, Dest$, Buffer$, ErrCode%)
DECLARE FUNCTION ASCII% (Work$)
DECLARE FUNCTION Exist% (FileName$)
DECLARE FUNCTION PDQParse$ (Work$)
DECLARE FUNCTION QPTrim$ (Work$)

' Myown Declarations
DECLARE FUNCTION JustifyL$ (Image$, Source$)
DECLARE FUNCTION ReplaceInSet$ (Set$, Char$, St$)
DECLARE SUB InsChar (Target$, Position, Char$)
DECLARE SUB DelChar (Target$, Position, Char$)

'   Local Declarations
DECLARE FUNCTION FonCheck(Answer$, FonTest$, LocalArea$)
DECLARE FUNCTION CheckDataBase(UserFon$, Recs, FileHandle)

' * * * * * PCBoard 14.5 USERS.SYS File Formats

TYPE USERSYSRECORD
   Version AS INTEGER            'PCBoard version number (i.e. 145) unsigned
   RecNo AS LONG                 'Record number from USER's file
   SizeOfRec AS INTEGER          'Size of "fixed" user record unsigned
   NumOfAreas AS INTEGER         'Number of conference areas (Main=1 thru 65535) unsigned
   NumOfBitFields AS INTEGER     'Number of Bit Map fields for conferences unsigned
   SizeOfBitFields AS INTEGER    'Size of each Bit Map field unsigned
   AppName AS STRING * 15        'Name of the Third Party Application (if any)
   AppVersion AS INTEGER         'Version number for the application (if any) unsigned
   AppSizeOfRec AS INTEGER       'Size of a "fixed length" record (if any) unsigned
   AppSizeOfConfRec AS INTEGER   'Size of each conference record (if any) unsigned
   AppRecOffset AS LONG          'Offset of AppRec into USERS.INF record (if any)
   Updated AS STRING * 1         'TRUE if the USERS.SYS file has been updated
   UserName AS STRING * 26       'User's Full Name (NUL terminated)
   CityState AS STRING * 25      'City and State (NULL terminated)
   Password AS STRING * 13       'Password (NULL terminated)
   BusPhone AS STRING * 14       'Business or Data Phone (NULL terminated)
   HomePhone AS STRING * 14      'Home or Voice Phone (NULL terminated)
   LastOnDate AS INTEGER         'Last Date on system (unsigned - Julian)
   LastOnTime AS STRING * 6      'Last Time on system (in hh:mm format) (NULL term)
   Expert AS STRING * 1          'Expert Mode - 1=Expert, 0=Novice
   Protocol AS STRING * 1        'Protocol (A thru Z)
   PackedFlags AS STRING * 1     'Dirty, ClrScrn, HasMail, DontAsk, Editor
   LastDirScan AS INTEGER        'Last date looked at directory (of DateType)
   SecLevel AS INTEGER           'Security Level
   TimesOn AS INTEGER            'Number of times on the system
   PageLength AS STRING * 1      'Page Length CHR$(X)
   Uploads AS INTEGER            'Number of Uploads   (unsigned)
   Downloads AS INTEGER          'Number of Downloads (unsigned)
   DailyDlBytes AS LONG          'Daily Download Bytes so far
   UserComment AS STRING * 31    'User Maintained Comment  (NULL terminated)
   SysopComment AS STRING * 31   'Sysop Maintained Comment (NULL terminated)
   TimeSpent AS INTEGER          'Elapsed Time on system on last date called
   SubDate AS INTEGER            'Subscription Registration Date (unsigned Julian)
   ExpSecLevel AS INTEGER        'Subscription Expired Security Level
   LastConference AS INTEGER     'Last Conference left - (unsigned)
   TotalDownloads AS LONG        'Total Bytes Download - all calls
   TotalUploads AS LONG          'Total Bytes Upload - all calls
   Delete AS STRING * 1          'Positive Delete Flag to Delete User (Repack) 1=delete this record, 0=keep
   InfPointer AS LONG            'Pointer into USERS.INF record
   Space2 AS STRING * 9          'Bytes 391-399 from the USERS file
   MsgsRead AS LONG              'Number of messages the user has read in PCB
   MsgsLeft AS LONG              'Number of messages the user has left in PCB
END TYPE

TYPE FonBase
    Number AS STRING * 12
    CrLf AS STRING * 2
END TYPE

CONST FALSE = 0 , TRUE = -1

FUNCTION FonCheck(Answer$, FonTest$, LocalArea$) STATIC
   FonTest$ = JustifyL$(SPACE$(13), ReplaceInSet$("():; ", "-", QPTrim$(Answer$)))
   FonCheck = TRUE
   IF LEFT$(FonTest$, 1) = "-" THEN
      DelChar FonTest$, 1, " "
   END IF
'   PRINT "Length:"; LEN(QPTrim$(FonTest$))
   SELECT CASE LEN(QPTrim$(FonTest$))
      CASE 7
         InsChar FonTest$, 4, "-"
         InsChar FonTest$, 1, LocalArea$ + "-"
      CASE 8
         InsChar FonTest$, 1, LocalArea$ + "-"
      CASE 10
         InsChar FonTest$, 7, "-"
         InsChar FonTest$, 4, "-"
      CASE 11
         IF (MID$(FonTest$, 4, 1)) = "-" THEN
            InsChar FonTest$, 7, "-"
         ELSE
            InsChar FonTest$, 4, "-"
         END IF
      CASE 12
      CASE ELSE
         FonCheck = FALSE
   END SELECT
   FonTest$ = QPTrim$(FonTest$)
END FUNCTION

FUNCTION CheckDataBase(UserFon$, Recs, FileHandle) STATIC
   DIM CheckFon AS FonBase
   FOR X = 1 TO Recs
      GET #FileHandle, X, CheckFon
'      PRINT UserFon$; " <> "; CheckFon.Number$
      IF UserFon$ = CheckFon.Number$ THEN
         CheckDataBase = TRUE
         EXIT FUNCTION
      END IF
   NEXT X
   CheckDataBase = FALSE
END FUNCTION

DIM USERSYS AS USERSYSRECORD, Buffer AS STRING * 8192
ConfigFile$ = "FONWATCH.CFG"

IF NOT Exist(ConfigFile$) THEN                 'Check for Config file
   PRINT CHR$(34); ConfigFile$; CHR$(34); " not found!"
   SetLevel 20                                 'Return error code
   END
ELSE
   OPEN ConfigFile$ FOR INPUT AS #1
      INPUT #1, DataBaseFile$
      INPUT #1, BadTextFile$
      INPUT #1, LocalArea$
      INPUT #1, BadLevel
   CLOSE #1
END IF

C$ = COMMAND$
PCBDir$ = PDQParse$(C$)        'Get the USERS.SYS location from Command Line
IF RIGHT$(PCBDir$, 1) <> "\" THEN PCBDir$ = PCBDir$ + "\"
SysFile$ = PCBDir$ + "USERS.SYS"
DoorTextFile$ = PCBDir$ + "PCBDOOR.TXT"
Failed1 = 0
Failed2 = 0

PRINT "FonWatch 1.00....Checking "; CHR$(34); SysFile$; CHR$(34)

IF NOT Exist(SysFile$) THEN                    'Check for USERS.SYS file
   PRINT CHR$(34); SysFile$; CHR$(34); " not found!"
   SetLevel 10                                 'Return error code
ELSE
   OPEN SysFile$ FOR BINARY AS #1
      GET #1,, USERSYS
      PRINT "       User: "; USERSYS.UserName$
      PRINT "    Sec Lev: "; USERSYS.SecLevel
      PRINT "Exp Sec Lev: "; USERSYS.ExpSecLevel
      PRINT "User Comment:"; USERSYS.UserComment$
      PRINT "SysopComment:"; USERSYS.SysopComment$
'      PRINT "Updated: "; HEX$(ASCII(USERSYS.Updated$))
'      Flags = ASCII(USERSYS.PackedFlags$)
'      PRINT "  Flags:   "; HEX$(Flags)
      IF Exist(DataBaseFile$) THEN
         OPEN DataBaseFile$ FOR RANDOM AS #2 LEN = 14
            Recs = LOF(2) \ 14
            IF FonCheck(USERSYS.BusPhone$, Phone$,  LocalArea$) THEN
               Failed1 = CheckDataBase(Phone$, Recs, 2)
            ELSE
               PRINT "Format bad:"; USERSYS.BusPhone$; "        :"; Phone$
            ENDIF
            IF FonCheck(USERSYS.HomePhone$, Phone$,  LocalArea$) THEN
               Failed2 = CheckDataBase(Phone$, Recs, 2)
            ELSE
               PRINT "Format bad:"; USERSYS.HomePhone$; "        :"; Phone$
            ENDIF
         CLOSE #2
      END IF
      IF Failed1 OR Failed2 THEN
         PRINT "User matched number in database"
         FCopy BadTextFile$, DoorTextFile$, Buffer$, ErrCode%
         SetLevel 1                                    'Return error code
         USERSYS.SecLevel = BadLevel
         USERSYS.ExpSecLevel = BadLevel
         USERSYS.Updated$ = CHR$(1)
         USERSYS.PackedFlags$ = CHR$(Flags OR &h01)
         PRINT "    Sec Lev: "; USERSYS.SecLevel
         PRINT "Exp Sec Lev: "; USERSYS.ExpSecLevel
         PRINT "Updated: "; HEX$(ASCII(USERSYS.Updated$))
'         Flags = ASCII(USERSYS.PackedFlags$)
'         PRINT "  Flags:   "; HEX$(Flags)
         PUT #1,1, USERSYS
      ELSE
         PRINT "User passed."
      END IF
   CLOSE
END IF
